#"""""""""""""""""""""""""""""""""""""""""""""
#""" DO NOT EDIT ANYTHING UNDER THIS LINE """
#"""     IF YOU DO THINGS COULD BREAK     """
#"""""""""""""""""""""""""""""""""""""""""""""

import es
import spe
import random
import cfglib
import playerlib
import weaponlib
import gamethread

info = es.AddonInfo() 
info.name        = 'Paintball Mod: Source' 
info.basename    = 'pbl'
info.version     = '0.0.1a Python'
info.date        = 'November 9, 2009'
info.url         = 'http://addons.eventscripts.com/addons/view/' + info.basename
info.description = 'Paintball Mod'
info.author      = '||Wolf||' 
es.ServerVar('pbl_version', info.version).makepublic()

config = cfglib.AddonCFG(es.getAddonPath(info.basename) + '/' + info.basename + ' Config.cfg')

config.text(info.name + ' release %s options' % info.version)
config.text('./addons/eventscripts/%(basename)s/%(basename)s.cfg' % {'basename':info.basename})
config.text(info.url)
config.text('')
config.text('Load this addon with: es_load ' + info.basename)
config.text('\n')

config.text('***** Paintball Settings *****')
pbl_freezeTime   = config.cvar('pbl_freezeTime',     3, 'Sets mp_pbl_freezeTime. (Default: 3)')   
pbl_clipSize     = config.cvar('pbl_clipSize',     250, 'Primary ammo amount.')   
pbl_reservedAmmo = config.cvar('pbl_reservedAmmo', 500, 'Secondary ammo amount.')
pbl_playerModel  = config.cvar('pbl_playerModel',    1, 'Turn on player models. (On: 1, Off: 0)')
config.text('\n')
config.text('\n')
config.write()

weapons = {}
weapons["mp5navy"] = {}
weapons["mp5navy"]["head"]     = 100
weapons["mp5navy"]["chest"]    = 100
weapons["mp5navy"]["pelvis"]   = 100
weapons["mp5navy"]["leftarm"]  = 100
weapons["mp5navy"]["rightarm"] = 100
weapons["mp5navy"]["leftleg"]  = 100
weapons["mp5navy"]["rightleg"] = 100

reloadtime = {
'usp': 2.8,
'glock': 2.25,
'deagle': 2.3,
'p228': 2.85,
'elite': 3.9,
'fiveseven': 3.3,
'm3': 2.5,
'xm1014': 2.5,
'mp5navy': 3.1,
'tmp': 2.2,
'p90': 3.44,
'mac10': 3.2,
'ump45': 3.6,
'galil': 3.02,
'famas': 3.4,
'ak47': 2.5,
'sg552': 2.85,
'm4a1': 3.1,
'aug': 3.85,
'scout': 3,
'awp': 3.7,
'g3sg1': 4.75,
'sg550': 3.85,
'm249': 5.8
}

weaponlist = ['usp', 'glock', 'p228', 'elite', 'deagle', 'nighthawk', 'compact', 'fiveseven', 'm3', 'xm1014', 'mp5navy', 'tmp', 'p90', 'mac10', 'ump45', 'galil', 'famas', 'ak47', 'sg552', 'm4a1', 'aug', 'scout', 'awp', 'g3sg1', 'sg550', 'm249']
pistols    = ['usp', 'glock', 'p228', 'elite', 'deagle', 'nighthawk', 'fiveseven']
shotguns   = ['m3', 'xm1014']

res = {}
res[0] = "None"
res[1] = "head"
res[2] = "chest"
res[3] = "pelvis"
res[4] = "leftarm"
res[5] = "rightarm"
res[6] = "leftleg"
res[7] = "rightleg"

colors  = ['cyan', 'green', 'pink', 'orange', 'yellow']

oldAmmo      = 0
oldClip      = 0
ammoSubtract = 0
newAmmo      = 0 

def PBLVariables():        
    es.ServerVar('mp_freezetime').set(pbl_freezeTime)

def load():
    config.execute()
    Downloads()
    spe.registerPreHook("player_hurt", player_hurt_hook)
    spe.registerPreHook("weapon_fire", weapon_fire_hook)
    PBLVariables()
    es.doblock('corelib/noisy_on')
   
def unload():
    spe.unregisterPreHook("player_hurt", player_hurt_hook)
    spe.unregisterPreHook("weapon_fire", weapon_fire_hook)
    es.doblock('corelib/noisy_off')
 
def player_hurt_hook(ev):
	hitGroup     = int(ev['hitgroup'])
	weapon       = str(ev['weapon']).replace("weapon_","")
	hitGroupName = res[hitGroup]
    
	if not weapon in weapons: return
	if not hitGroupName in weapons[weapon]:	return
    
	addDamage = weapons[weapon][hitGroupName]	
	if addDamage == -1:	return
    
	userid   = int(ev['userid'])
	attacker = int(ev['attacker'])
	damage   = int(ev['dmg_health'])
    
	difference = addDamage - damage
	if difference < 0:
		curHealth = es.getplayerprop(userid,"CBasePlayer.m_iHealth")
		curHealth += (difference*-1)
		es.setplayerprop(userid,"CBasePlayer.m_iHealth",curHealth)
	elif difference > 0:
		es.server.queuecmd("damage %s %s 2 %s"%(userid,difference,attacker))

def weapon_fire_hook(ev):
    weapon = str(ev['weapon']).replace("weapon_","")
    userid = int(ev['userid'])

def es_map_start(ev):
    Downloads()
   
def round_start(ev):
    ESTCheck()
    SetAmmo(ev['userid'], playerlib.getPlayer(ev['userid']).get('primary').replace('weapon_', ''))
    SetAmmo(ev['userid'], playerlib.getPlayer(ev['userid']).get('secondary').replace('weapon_', '')) 
    
def Downloads():
    ESTCheck()
    
    if pbl_playerModel == 1:
        es.stringtable('downloadables', 'models/player/techknow/masterchief/blue_mc.dx80.vtx')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/blue_mc.dx90.vtx')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/blue_mc.mdl')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/blue_mc.phy')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/blue_mc.sw.vtx')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/blue_mc.vvd')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/red_mc.dx80.vtx')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/red_mc.dx90.vtx')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/red_mc.mdl')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/red_mc.phy')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/red_mc.sw.vtx')
        es.stringtable('downloadables', 'models/player/techknow/masterchief/red_mc.vvd')

        es.stringtable('downloadables', 'materials/models/player/techknow/masterchief/blue_mc.vmt')
        es.stringtable('downloadables', 'materials/models/player/techknow/masterchief/blue_mc.vtf')
        es.stringtable('downloadables', 'materials/models/player/techknow/masterchief/mc_n.vtf')
        es.stringtable('downloadables', 'materials/models/player/techknow/masterchief/red_mc.vmt')
        es.stringtable('downloadables', 'materials/models/player/techknow/masterchief/red_mc.vtf')
        es.stringtable('downloadables', 'materials/models/player/techknow/masterchief/specmap.vtf')
        es.stringtable('downloadables', 'materials/models/player/techknow/masterchief/visor.vmt')
        es.stringtable('downloadables', 'materials/models/player/techknow/masterchief/visor.vtf')
       
    for color in colors:
        es.stringtable('downloadables', 'materials/paintball/pb_%s.vmt' %color)
        es.stringtable('downloadables', 'materials/paintball/pb_%s.vtf' %color)
      
def ESTCheck():
    if not es.exists('variable', 'est_version'): 
        sendMessage('es_tools')
   
def bullet_impact(ev):
    es.server.queuecmd('est_effect_35 #h 0 paintball/pb_%s.vmt "%s %s %s"' %(random.choice(colors), ev['x'], ev['y'], ev['z']))
    
def stripWeapon(userid, weapon):
    userid = int(userid)
    handle = es.getplayerhandle(userid)
    for index in weaponlib.getIndexList(weapon):
        if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle:
            es.server.queuecmd('es_xremove %s' % index)
            if es.createplayerlist(userid)[userid]['weapon'] == weaponlib.getWeapon(weapon):
                es.cexec(userid, 'lastinv')

def item_pickup(ev):   
    if ev['item'] != 'mp5navy':
        stripWeapon(ev['userid'], ev['item'])
    if ev['item'] in weaponlist:
        SetAmmo(ev['userid'], ev['item']) 

def player_spawn(ev):
    userid = ev['userid']    
    player = playerlib.getPlayer(userid)
    team   = es.getplayerteam(userid)
    
    es.setplayerprop(userid, 'CBasePlayer.m_fFlags', 32)
    gamethread.delayed(pbl_freezeTime,  es.setplayerprop, (userid, 'CBasePlayer.m_fFlags', 1))
    
    if team == 2 and pbl_playerModel == 1:
        player.set('model', 'models/player/techknow/masterchief/red_mc.mdl')
    elif team == 3 and pbl_playerModel == 1:
        player.set('model', 'models/player/techknow/masterchief/blue_mc.mdl')
    
    if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag') and es.getplayerteam(userid) > 1:
        es.server.cmd('est_RemoveWeapon %s %s'%(userid, 1))
        es.server.cmd('est_RemoveWeapon %s %s'%(userid, 2))			
        es.server.cmd('est_RemoveWeapon %s %s'%(userid, 3))			
        es.server.cmd('est_RemoveWeapon %s %s'%(userid, 4))							
        es.server.cmd('est_RemoveWeapon %s %s'%(userid, 5))			
        es.server.queuecmd('es_xgive %s weapon_mp5navy' %userid)  
        
        SetAmmo(ev['userid'], playerlib.getPlayer(ev['userid']).get('primary').replace('weapon_', ''))
        SetAmmo(ev['userid'], playerlib.getPlayer(ev['userid']).get('secondary').replace('weapon_', '')) 
        
def weapon_reload(ev):
    SetClip(ev['userid'], playerlib.getPlayer(ev['userid']).get('weapon').replace('weapon_', '')) 

def round_start(ev):
    SetClip(ev['userid'], playerlib.getPlayer(ev['userid']).get('primary').replace('weapon_', ''))
    SetClip(ev['userid'], playerlib.getPlayer(ev['userid']).get('secondary').replace('weapon_', ''))

def weapon_fire_on_empty(ev):
    gamethread.delayed(.5, SetClip, (ev['userid'], playerlib.getPlayer(ev['userid']).get('weapon').replace('weapon_', ''))) 
    
def SetClip(userid, weapon):
    oldAmmo = playerlib.getPlayer(userid).get("ammo", ("2" if weapon in pistols else "1"))
    oldClip = playerlib.getPlayer(userid).get("clip", ("2" if weapon in pistols else "1"))
    ammoSubtract = pbl_clipSize - oldClip
    if oldAmmo == 0:
        return
    if ammoSubtract < oldAmmo:
        newAmmo = oldAmmo - ammoSubtract
        if weapon in shotguns:
            playerlib.getPlayer(userid).set("ammo", (1, 3))
            gamethread.delayed(reloadtime[weapon], playerlib.getPlayer(userid).set, ("ammo", (1, newAmmo)))
        else:
            playerlib.getPlayer(userid).set("clip", ("2" if weapon in pistols else "1", 0))
            gamethread.delayed(reloadtime[weapon], playerlib.getPlayer(userid).set, ("clip", ("2" if weapon in pistols else "1", pbl_clipSize)))
            gamethread.delayed(reloadtime[weapon], playerlib.getPlayer(userid).set, ("ammo", ("2" if weapon in pistols else "1", newAmmo)))
    else:
        newAmmo = 0
        if weapon in shotguns:
            playerlib.getPlayer(userid).set("ammo", (1, 3))
            gamethread.delayed(reloadtime[weapon], playerlib.getPlayer(userid).set, ("ammo", (1, newAmmo)))
        else:
            playerlib.getPlayer(userid).set("clip", ("2" if weapon in pistols else "1", 0))
            gamethread.delayed(reloadtime[weapon], playerlib.getPlayer(userid).set, ("clip", ("2" if weapon in pistols else "1", oldAmmo)))
            gamethread.delayed(reloadtime[weapon], playerlib.getPlayer(userid).set, ("ammo", ("2" if weapon in pistols else "1", newAmmo))) 

def SetAmmo(userid, item):
    gamethread.delayed(.1, playerlib.getPlayer(userid).set, ("clip", ("2" if item in pistols else "1", pbl_clipSize)))
    gamethread.delayed(.1, playerlib.getPlayer(userid).set, ("ammo", ("2" if item in pistols else "1", pbl_reservedAmmo)))